# AUTOGENERATED! DO NOT EDIT! File to edit: 00_core.ipynb (unless otherwise specified).

__all__ = ['Multimethod']

# Cell
class Multimethod:
    """
    Core class that dispatch the actual
    computation to different functions
    according to arbitary condition.
    """
    def __init__(self, name, dispatch):
        self.name = name
        self.dispatch = dispatch
        self.funcs = {}

    def add(self, sig):
        def decorator(func):
           self.funcs[sig] = func
        return decorator

    def __call__(self, x):
        sig = self.dispatch(x)
        try:
            return self.funcs[sig](x)
        except KeyError:
            raise Exception(f"Not implement for {sig}")